//
//  SIWorkUnit.m
//  Kompressor2
//
//  Created by Daniel Vollmer on 21.12.06.
//  Copyright 2006 [maven] heavy industries. All rights reserved.
//

#import "SIWorkUnit.h"


@implementation SIWorkUnit

- (id)initWithTarget:(id)target withSelector:(SEL)selector withArgument:(id)argument withDidEndSelector:(SEL)didEndSelector
{
	if (![target respondsToSelector:selector])
	{
		NSLog(@"Cannot create SIWorkUnit as target %@ refuses to perform %@!", target, NSStringFromSelector(selector));
		return nil;
	}
	if (self = [super init])
	{
//		NSLog(@"init: %@", self);
		_target = [target retain];
		_selector = selector;
		_argument = [argument retain];
		_didEndSelector = didEndSelector;
	}
	return self;
}

- (void)dealloc
{
//	NSLog(@"dealloc: %@", self);
	[_target release];
	[_argument release];
	[super dealloc];
}

- (void)performWork
{
	id result;
	
	result = [_target performSelector:_selector withObject:_argument];
	if (_didEndSelector && [_target respondsToSelector:_didEndSelector])
	{
		if (!result)
			result = _argument; // if we didn't get a return value, pass in argument again
		[_target performSelectorOnMainThread:_didEndSelector withObject:result waitUntilDone:NO];
	}
}

- (BOOL)isRelatedTo:(id)object
{
	return object == _target || object == _argument;
}

@end
